//+------------------------------------------------------------------+
//|                                          PC_Breakout_Alpha_5.mq4 |
//|                 Copyright 2013, Jonathan Siebern & pipcompounder |
//|                                        http://www.babypips.com   |
//+------------------------------------------------------------------+
#property copyright "Copyright 2013, Jonathan Siebern & pipcompounder"
#property link      "http://www.babypips.com"

#import "kernel32.dll"
   //void GetLocalTime(int& TimeArray[]);
   //void GetSystemTime(int& TimeArray[]);
   int  GetTimeZoneInformation(int& TZInfoArray[]);
#import

//--- External Variables
extern string  COM_GMT_1               = "--- Time(zone) Settings";
extern string  COM_GMT_2               = "(GMT - HH:MM)";
extern string  Reference_Candle_Time   = "13:15";
extern int     Reference_Candle_Back   = 1;
extern string  Close_Pending_Time      = "20:00";
extern bool    Also_Close_Open         = true;
extern bool    Use_Automatic_GMT       = false;
extern int     Manual_GMT_Offset       = 2;

extern string  COM_TRADES_1            = "--- Trade Settings";
extern string  COM_TRADES_2            = "SL;DEV_BUY;DEV_SELL|TP;TP_VAL|BE;BE_TRIG;BE_DEV|TS;TS_TRIG;TS_STEP|MM;MM_VAL";
extern string  Trade_Info              = "0;30;10|1;400|0;0;0|0;0;0|2;0.02";
extern int     Max_SL                  = 300;
extern bool    Close_Pending_After_TP  = true;
extern int     Friday_Close_Hour       = 20;

//extern string  COM_RE                  = "--- Reentry Settings";
//extern int     Re_Num                  = 1;
//extern int     Re_Minutes              = 60;

extern string  COM_MM                  = "--- Money Management Settings";
extern int     MM_Mode_2_Value         = 100;

extern string  COM_EXE                 = "--- Trade Execution Settings";
extern bool    IsECN                   = false;
extern int     Max_Slippage            = 30;
extern int     Max_Retries             = 5;

extern string  COM_EA                  = "--- EA Settings";
extern int     Magic_Number            = 516189651;
extern string  EA_Name                 = "PC_Breakout_Alpha_5";

//--- Internal Variables
int            GMT_Offset              = 1;
string         pA[9];
int            StopLevel               = 0;

bool           LOCK                    = false;

//Variables for trading times
int            TM_REF[2];
datetime       TM_REF_T;
int            TM_CLOSE[2];
datetime       TM_CLOSE_T;

//Locked trading time variables
datetime       TM_REF_L;
datetime       TM_CLOSE_L;

//Variables for trade management
int            T_NUM                   = 0;
int            T_ACTIVE                = 0;

int            T_SL[];
int            T_SL_BUY[];
int            T_SL_SELL[];

int            T_TP[];
int            T_TP_VAL[];

int            T_BE[];
int            T_BE_TRIG[];
int            T_BE_DEV[];

int            T_TS[];
int            T_TS_TRIG[];
int            T_TS_STEP[];
bool           T_TS_ARMED_B[];
bool           T_TS_ARMED_S[];

int            T_MM[];
double         T_MM_VAL[];

int            T_RE_B[];
int            T_RE_S[];

//Variables for MM
string         a="",b="",c="",res[],NormalizedSymbol,BaseCurr,QuoteCurr,AccCurr;
string         Currencies[] = {"AED", "AUD", "BHD", "BRL", "CAD", "CHF", "CNY", "CYP", "CZK", "DKK", "DZD", "EEK", "EGP", "EUR", "GBP", "HKD", "HRK", "HUF", "IDR", "ILS", "INR", "IQD", "IRR", "ISK", "JOD", "JPY", "KRW", "KWD", "LBP", "LTL", "LVL", "LYD", "MAD", "MXN", "MYR", "NOK", "NZD", "OMR", "PHP", "PLN", "QAR", "RON", "RUB", "SAR", "SEK", "SGD", "SKK", "SYP", "THB", "TND", "TRY", "TWD", "USD", "VEB", "XAG", "XAU", "YER", "ZAR"};
double         AccountValue;


//+------------------------------------------------------------------+
//| expert initialization function                                   |
//+------------------------------------------------------------------+
int init() {
   //---- Initialize variables for percentage MM
   string predimsuf = DetectPredimsuf(Symbol());
   SplitString(predimsuf,";",res);
   
   a = res[1]; b = res[2]; c = res[3];
   
   NormalizedSymbol = NormalizeSymbol(Symbol(),a,b,c);
   BaseCurr = StringSubstr(NormalizedSymbol,0,3);
   QuoteCurr = StringSubstr(NormalizedSymbol,3,3);
   AccCurr = AccountCurrency();
   
   //Init
   pA[0] = "-------------------------------------------------------------------------------\n" + EA_Name + "\n-------------------------------------------------------------------------------\n";
   
   //Timezone settings
   pA[0] = pA[0] + "Timezone settings:\n";
   GMT_Offset = Manual_GMT_Offset;
   if (Use_Automatic_GMT) GMT_Offset = GetShiftGMT();
   pA[0] = pA[0] + "GMT-Offset: " + GMT_Offset;
   string tm[];
   if (SplitString(Reference_Candle_Time,":",tm,2)) {
      TM_REF[0] = StrToInteger(tm[0]);
      TM_REF[1] = StrToInteger(tm[1]);
      pA[0] = pA[0] + "\n\nReference Candle Time:      " + Reference_Candle_Time + " GMT";
   }
   else {
      pA[0] = pA[0] + "\n!!! ERROR: Provide Reference Candle Time in format \"HH:MM\"";
      Print("TM - ERROR: Provide Reference Candle Time in format \"HH:MM\"");
      LOCK = true;
   }
   
   if (SplitString(Close_Pending_Time,":",tm,2)) {
      TM_CLOSE[0] = StrToInteger(tm[0]);
      TM_CLOSE[1] = StrToInteger(tm[1]);
      pA[0] = pA[0] + "\nClose Pending Time:           " + Close_Pending_Time + " GMT";
   }
   else {
      pA[0] = pA[0] + "\n!!! ERROR: Provide Close Pending Time in format \"HH:MM\"";
      Print("TM - ERROR: Provide Close Pending Time in format \"HH:MM\"");
      LOCK = true;
   }
   pA[0] = pA[0] + "\n-------------------------------------------------------------------------------\n";
   
   //Display trade settings
   StopLevel = MarketInfo(Symbol(), MODE_STOPLEVEL);
   pA[0] = pA[0] + "Trade information:\n";
   pA[0] = pA[0] + "Stoplevel: " + StopLevel + "\n";
   
   if (InterpretTradeString()) {
      pA[0] = pA[0] + T_NUM;
      if (T_NUM == 1) pA[0] = pA[0] + " Trade has";
      else pA[0] = pA[0] + " Trades have";
      pA[0] = pA[0] + " been defined";
   }
   else {
      pA[0] = pA[0] + "!!! ERROR: Provide Trade information with pattern \"SL;DEV_BUY;DEV_SELL|TP;VAL|BE;TRIG;DEV|TS;TRIG;STEP|MM;VAL|COMMENT\" divided by \"/\"";
      Print("T_INFO - ERROR: Provide Trade information with pattern \"SL;DEV_BUY;DEV_SELL|TP;VAL|BE;TRIG;DEV|TS;TRIG;STEP|MM;VAL|COMMENT\" divided by \"/\"");
      LOCK = true;
   }
   pA[0] = pA[0] + "\n-------------------------------------------------------------------------------";
   
   //Assign the trade times
   DrawClock();
   TM_REF_L = TM_REF_T;
   TM_CLOSE_L = TM_CLOSE_T;
   
   //Calculate open positions
   T_ACTIVE = ExistingOrders(true);
   
   CPA();
   
   return (0);
   
}
//+------------------------------------------------------------------+
//| expert deinitialization function                                 |
//+------------------------------------------------------------------+
int deinit() {
   
   return (0);
}
//+------------------------------------------------------------------+
//| expert start function                                            |
//+------------------------------------------------------------------+
int start() {
   //Lock EA if necessary
   if (LOCK) return (0);
   
   //Include a clock
   DrawClock();
   
   datetime gmt = TimeCurrent()-(GMT_Offset*60*60);
   //Check for trading actions
   if ((TM_REF_L-gmt) < 0) {
      //Reset trade settings
      InterpretTradeString();
      
      //Reset the timer
      TM_REF_L = TM_REF_T;
      
      //Open new orders
      double Ref_High = iHigh(Symbol(),Period(),Reference_Candle_Back);
      double Ref_Low  = iLow(Symbol(),Period(),Reference_Candle_Back);
      OpenNewOrders(Ref_High,Ref_Low);
   }
   
   //Check for closing the pending
   if ((TM_CLOSE_L-gmt) < 0) {
      //Reset the timer
      TM_CLOSE_L = TM_CLOSE_T;
      
      //Close pendings
      ClosePendingOrders();
      if (Also_Close_Open) CloseAllOrders();
   }
   
   //Check if there are modifications needed
   int exist = ExistingOrders(true);
   if (exist > 0) {
      ModifyOrders();
   }
   
   //Check if a TP was hit
   if (Close_Pending_After_TP && T_ACTIVE > exist) {
      //Determine if TP was hit
      if (SelectClosedTrade(1)) {
         if (OrderProfit() > 0) ClosePendingOrders();
      }
   }
   
   //Check for reentries
   //if (Re_Num > 0 && T_ACTIVE > exist) {
   //   SelectClosedTrade(1);
   //   if (OrderProfit() <= 0 && OrderOpenTime() > (TimeCurrent()-(Re_Minutes*60)) && (OrderType() == OP_BUY || OrderType() == OP_SELL)) {
   //      double p1 = OrderOpenPrice();
   //      SelectClosedTrade(2);
   //      if (OrderProfit() <= 0 && OrderOpenTime() > (TimeCurrent()-(Re_Minutes*60)) && (OrderType() == OP_BUY || OrderType() == OP_SELL)) {
   //         double p2 = OrderOpenPrice();
   //         if (p1 > p2) OpenNewOrders(p1,p2);
   //         else OpenNewOrders(p2,p1);
   //      }
   //   }
   //}
   
   //Check if trades need to be closed on friday
   if (TimeDayOfWeek(gmt) == 5 && TimeHour(gmt) == Friday_Close_Hour) {
      CloseAllOrders();
   }
   
   T_ACTIVE = exist;
   CPA();
   return (0);
}
//+------------------------------------------------------------------+
//| Select closed Trade                                              |
//+------------------------------------------------------------------+
bool SelectClosedTrade(int numBack) {
   int i,x = 0,hTotal = OrdersHistoryTotal();
   Print(hTotal);
   for (i=(hTotal-1);i>=0;i--) {
      if (OrderSelect(i,SELECT_BY_POS,MODE_HISTORY) == false) continue;
      if (OrderMagicNumber() == Magic_Number && OrderSymbol() == Symbol()) {
         x++;
         if (numBack == x) return (true);
      }
   }
   return (false);
}
//+------------------------------------------------------------------+
//| Close all orders                                                 |
//+------------------------------------------------------------------+
void CloseAllOrders() {
   int i,total = OrdersTotal();
   for (i=0;i<total;i++) {
      if (OrderSelect(i,SELECT_BY_POS) == false) continue;
      if (OrderMagicNumber() == Magic_Number && OrderSymbol() == Symbol()) {
         if (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP) OrderDelete(OrderTicket());
         else {
            int y,err;
            double p;
            RefreshRates();
            if (OrderType() == OP_BUY) p = Bid;
            else p = Ask;
            for (y=0;y<Max_Retries;y++) {
               if (OrderClose(OrderTicket(),OrderLots(),p,Max_Slippage)) {
                  break;
               }
               else {
                  err = GetLastError();
                  if (err==0 || err==4 || err==136 || err==137 || err==138 || err==146) {//Busy errors
                     Sleep(1500);
                     continue;
                  }
                  else {
                     Print("TRADE ERROR: Close Error Code: " + err);
                     break;
                  }
               }
            }
         }
      }
   }
   ClosePendingOrders();
}
//+------------------------------------------------------------------+
//| Modify Open Orders                                               |
//+------------------------------------------------------------------+
void ModifyOrders() {
   RefreshRates();
   double CurrentBid = MarketInfo(Symbol(),MODE_BID);
   double CurrentAsk = MarketInfo(Symbol(),MODE_ASK);
   
   int i,total = OrdersTotal();
   for (i=0;i<total;i++) {
      if (OrderSelect(i,SELECT_BY_POS) == false) continue;
      if (OrderMagicNumber() == Magic_Number && OrderSymbol() == Symbol() && (OrderType() == OP_BUY || OrderType() == OP_SELL)) {
         string s[];
         SplitString(OrderComment(),"_",s);
         int tN = StrToInteger(s[2]);
         double newSL = -1;
         
         //Break Even & Trailing Stop Setting
         if (OrderType() == OP_BUY) {
            //BUY
            if (T_BE[tN] == 1 && OrderStopLoss() < OrderOpenPrice()+(T_BE_DEV[tN]*Point)) {
               //BE
               if (CurrentBid >= OrderOpenPrice()+(T_BE_TRIG[tN]*Point)) newSL = OrderOpenPrice()+(T_BE_DEV[tN]*Point);
            }
            else if (T_TS[tN] == 1) {
               //Trailing
               if (CurrentBid >= OrderOpenPrice()+(T_TS_TRIG[tN]*Point) || T_TS_ARMED_B[tN]) {
                  T_TS_ARMED_B[tN] = true;
                  if (CurrentBid >= OrderStopLoss()+(T_TS_STEP[tN]*Point)) newSL = CurrentBid-(T_TS_STEP[tN]*Point);
               }
            }
         }
         else {
            //SELL
            if (T_BE[tN] == 1 && OrderStopLoss() > OrderOpenPrice()-(T_BE_DEV[tN]*Point)) {
               //BE
               if (CurrentAsk <= OrderOpenPrice()-(T_BE_TRIG[tN]*Point)) newSL = OrderOpenPrice()-(T_BE_DEV[tN]*Point);
            }
            else if (T_TS[tN] == 1) {
               //Trailing
               if (CurrentAsk <= OrderOpenPrice()-(T_TS_TRIG[tN]*Point) || T_TS_ARMED_S[tN]) {
                  T_TS_ARMED_S[tN] = true;
                  if (CurrentAsk <= OrderStopLoss()-(T_TS_STEP[tN]*Point)) newSL = CurrentAsk-(T_TS_STEP[tN]*Point);
               }
            }
         }
         //MODIFY IF NECESSARY
         if (newSL > -1) {
            int y,err;
            for (y=0;y<Max_Retries;y++) {
               if (OrderModify(OrderTicket(),OrderOpenPrice(),newSL,OrderTakeProfit(),0,CLR_NONE)) {
                  break;
               }
               else {
                  err = GetLastError();
                  if (err==0 || err==4 || err==136 || err==137 || err==138 || err==146) {//Busy errors
                     Sleep(1500);
                     continue;
                  }
                  else {
                     Print("TRADE ERROR: Modify Buy Stop Error Code: " + err);
                     break;
                  }
               }
            }
         }
      }
   }
   
   
}
//+------------------------------------------------------------------+
//| Check for existing Orders                                        |
//+------------------------------------------------------------------+
void ClosePendingOrders() {
   int i,total = OrdersTotal();
   for (i=0;i<total;i++) {
      if (OrderSelect(i,SELECT_BY_POS) == false) continue;
      if (OrderMagicNumber() == Magic_Number && OrderSymbol() == Symbol() && (OrderType() == OP_BUYSTOP || OrderType() == OP_SELLSTOP)) {
         OrderDelete(OrderTicket());
      }
   }
}
//+------------------------------------------------------------------+
//| Check for existing Orders                                        |
//+------------------------------------------------------------------+
int ExistingOrders(bool NonPendingOnly = false) {
   int x = 0,i,total = OrdersTotal();
   for (i=0;i<total;i++) {
      if (OrderSelect(i,SELECT_BY_POS) == false) continue;
      if (OrderMagicNumber() == Magic_Number && OrderSymbol() == Symbol() && (!NonPendingOnly || (OrderType() == OP_BUY || OrderType() == OP_SELL))) x++;
   }
   return (x);
}
//+------------------------------------------------------------------+
//| Open new Orders                                                  |
//+------------------------------------------------------------------+
void OpenNewOrders(double Ref_High,double Ref_Low) {
   int i;
   for (i=0;i<T_NUM;i++) {
      //Take care of reentries
      //if (Re_Num > 0 && T_RE_B[i] > Re_Num) continue;
      T_RE_B[i]++;
      
      RefreshRates();
      double CurrentBid = MarketInfo(Symbol(), MODE_BID);
      double CurrentAsk = MarketInfo(Symbol(), MODE_ASK);
      int    ticket,err;
      
      //Put up long position
      double EntryLong = Ref_High+(T_SL_BUY[i]*Point);
      if (CurrentAsk >= EntryLong-StopLevel*Point) EntryLong = CurrentAsk + StopLevel*Point;
      double StopLong = Ref_Low-(T_SL_SELL[i]*Point);
      double ProfitLong = EntryLong+(T_TP_VAL[i]*Point);
      
      //Check for MAX-SL
      if ((EntryLong-StopLong) > (Max_SL*Point)) StopLong = EntryLong-(Max_SL*Point);
      
      //Determine Lot size
      double LotLong = T_MM_VAL[i];
      if (T_MM[i] == 1) LotLong = CalculateLotByRisk(((EntryLong-StopLong)/Point),T_MM_VAL[i]);
      if (T_MM[i] == 2) LotLong = NormalizeDouble(((AccountBalance()/MM_Mode_2_Value)*T_MM_VAL[i]),2);
      
      while (IsTradeContextBusy()) Sleep(50);
      
      int x,y;
      for (x=0;x<Max_Retries;x++) {
         ticket = 0;
         if (!IsECN) {
            ticket = OrderSend(Symbol(),OP_BUYSTOP,LotLong,EntryLong,Max_Slippage,StopLong,ProfitLong,"PCB_LONG_"+i,Magic_Number,0,CLR_NONE);
            if (ticket > 0) {
               break;
            }
            else {
               err = GetLastError();
               if (err==0 || err==4 || err==136 || err==137 || err==138 || err==146) {//Busy errors
                  Sleep(1500);
                  continue;
               }
               else {
                  Print("TRADE ERROR: Open Buy Stop Error Code: " + err);
                  break;
               }
            }
         }
         else {
            ticket = OrderSend(Symbol(),OP_BUYSTOP,LotLong,EntryLong,Max_Slippage,0,0,"PCB_LONG_"+i,Magic_Number,0,CLR_NONE);
            if (ticket > 0) {
               for (y=0;y<Max_Retries;y++) {
                  OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
                  if (OrderModify(OrderTicket(),OrderOpenPrice(),StopLong,ProfitLong,0,Blue)) {
                     break;
                  }
                  else {
                     err = GetLastError();
                     if (err==0 || err==4 || err==136 || err==137 || err==138 || err==146) {//Busy errors
                        Sleep(1500);
                        continue;
                     }
                     else {
                        Print("TRADE ERROR: Modify Buy Stop Error Code: " + err);
                        break;
                     }
                  }
               }
            }
            else {
               err = GetLastError();
               if (err==0 || err==4 || err==136 || err==137 || err==138 || err==146) {//Busy errors
                  Sleep(1500);
                  continue;
               }
               else {
                  Print("TRADE ERROR: Open Buy Stop Error Code: " + err);
                  break;
               }
            }
         }
      }
      
      
      ///////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
      
      //Take care of reentries
      //if (Re_Num > 0 && T_RE_S[i] > Re_Num) continue;
      T_RE_S[i]++;
      
      RefreshRates();
      CurrentBid = MarketInfo(Symbol(), MODE_BID);
      CurrentAsk = MarketInfo(Symbol(), MODE_ASK);
      
      //Put up short position
      double EntryShort = Ref_Low-(T_SL_SELL[i]*Point);
      if (CurrentBid <= EntryShort+StopLevel*Point) EntryShort = CurrentBid - StopLevel*Point;
      double StopShort = Ref_High+(T_SL_BUY[i]*Point);
      double ProfitShort = EntryShort-(T_TP_VAL[i]*Point);
      
      //Check for MAX-SL
      if ((StopShort-EntryShort) > (Max_SL*Point)) StopShort = EntryShort+(Max_SL*Point);
      
      //Determine Lot size
      double LotShort = T_MM_VAL[i];
      if (T_MM[i] == 1) LotShort = CalculateLotByRisk(((StopShort-EntryShort)/Point),T_MM_VAL[i]);
      if (T_MM[i] == 2) LotShort = NormalizeDouble(((AccountBalance()/MM_Mode_2_Value)*T_MM_VAL[i]),2);
      
      while (IsTradeContextBusy()) Sleep(50);
      
      for (x=0;x<Max_Retries;x++) {
         ticket = 0;
         if (!IsECN) {
            ticket = OrderSend(Symbol(),OP_SELLSTOP,LotShort,EntryShort,Max_Slippage,StopShort,ProfitShort,"PCB_SHORT_"+i,Magic_Number,0,CLR_NONE);
            if (ticket > 0) {
               break;
            }
            else {
               err = GetLastError();
               if (err==0 || err==4 || err==136 || err==137 || err==138 || err==146) {//Busy errors
                  Sleep(1500);
                  continue;
               }
               else {
                  Print("TRADE ERROR: Open Buy Stop Error Code: " + err);
                  break;
               }
            }
         }
         else {
            ticket = OrderSend(Symbol(),OP_SELLSTOP,LotShort,EntryShort,Max_Slippage,0,0,"PCB_SHORT_"+i,Magic_Number,0,CLR_NONE);
            if (ticket > 0) {
               for (y=0;y<Max_Retries;y++) {
                  OrderSelect(ticket,SELECT_BY_TICKET,MODE_TRADES);
                  if (OrderModify(OrderTicket(),OrderOpenPrice(),StopShort,ProfitShort,0,Red)) {
                     break;
                  }
                  else {
                     err = GetLastError();
                     if (err==0 || err==4 || err==136 || err==137 || err==138 || err==146) {//Busy errors
                        Sleep(1500);
                        continue;
                     }
                     else {
                        Print("TRADE ERROR: Modify Buy Stop Error Code: " + err);
                        break;
                     }
                  }
               }
            }
            else {
               err = GetLastError();
               if (err==0 || err==4 || err==136 || err==137 || err==138 || err==146) {//Busy errors
                  Sleep(1500);
                  continue;
               }
               else {
                  Print("TRADE ERROR: Open Buy Stop Error Code: " + err);
                  break;
               }
            }
         }
      }
   }
}
//+------------------------------------------------------------------+
//| Draw the Clock on the chart                                      |
//+------------------------------------------------------------------+
void DrawClock() {
   //Calculate Time   
   datetime gmt   = (TimeCurrent()-(GMT_Offset*60*60));
   
   TM_REF_T       =  gmt-(TimeHour(gmt)*60*60)-(TimeMinute(gmt)*60)-TimeSeconds(gmt);
   TM_REF_T       = TM_REF_T + (TM_REF[0]*60*60)+(TM_REF[1]*60);
   if (gmt > TM_REF_T) TM_REF_T = TM_REF_T + 86400;
   
   TM_CLOSE_T     = gmt-(TimeHour(gmt)*60*60)-(TimeMinute(gmt)*60)-TimeSeconds(gmt);
   TM_CLOSE_T     = TM_CLOSE_T + (TM_CLOSE[0]*60*60)+(TM_CLOSE[1]*60);
   if (gmt > TM_CLOSE_T) TM_CLOSE_T = TM_CLOSE_T + 86400;
   
   //Calculate Leftovers
   int      ll = (TM_REF_T-gmt);
   double   ld = ll/60.0;
   int      li = ll%60;          //Seconds
            ll = (ll-ll%60)/60;
   double   hd = ll/60.0;
   int      md = ll%60;         //Minutes
            ll = (ll-ll%60)/60; //Hours
   string   hh,mm,ss;
   hh = ll;
   if (StringLen(hh) == 1) hh = "0" + hh;
   mm = md;
   if (StringLen(mm) == 1) mm = "0" + mm;
   ss = li;
   if (StringLen(ss) == 1) ss = "0" + ss;
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   pA[1] = "Time until reference candle:  " + hh + ":" + mm + ":" + ss;
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
            ll = (TM_CLOSE_T-gmt);
            ld = ll/60.0;
            li = ll%60;          //Seconds
            ll = (ll-ll%60)/60;
            hd = ll/60.0;
            md = ll%60;         //Minutes
            ll = (ll-ll%60)/60; //Hours
   hh = ll;
   if (StringLen(hh) == 1) hh = "0" + hh;
   mm = md;
   if (StringLen(mm) == 1) mm = "0" + mm;
   ss = li;
   if (StringLen(ss) == 1) ss = "0" + ss;
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   pA[1] = pA[1] + "\nTime until close pending:      " + hh + ":" + mm + ":" + ss;
   /////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////////
   pA[1] = pA[1] + "\n-------------------------------------------------------------------------------\n";
   
   CPA();
}
//+------------------------------------------------------------------+
//| Interpret Trade string                                           |
//+------------------------------------------------------------------+
bool InterpretTradeString() {
   string t[];
   SplitString(Trade_Info,"/", t);
   int i,c = ArraySize(t);
   T_NUM = c;
   //Resize Trade Arrays
   ArrayResize(T_SL,c);
   ArrayResize(T_SL_BUY,c);
   ArrayResize(T_SL_SELL,c);
   ArrayResize(T_TP,c);
   ArrayResize(T_TP_VAL,c);
   ArrayResize(T_BE,c);
   ArrayResize(T_BE_TRIG,c);
   ArrayResize(T_BE_DEV,c);
   ArrayResize(T_TS,c);
   ArrayResize(T_TS_TRIG,c);
   ArrayResize(T_TS_STEP,c);
   ArrayResize(T_TS_ARMED_B,c);
   ArrayResize(T_TS_ARMED_S,c);
   ArrayResize(T_MM,c);
   ArrayResize(T_MM_VAL,c);
   ArrayResize(T_RE_B,c);
   ArrayResize(T_RE_S,c);
   
   //Loop the trades and put them into respective arrays
   for (i=0;i<c;i++) {
      string s[];
      if (SplitString(t[i],"|",s,5)) {
         string p[];
         int x;
         double y;
         //--- SL
         if (SplitString(s[0],";",p,3)) {
            x = StrToInteger(p[0]);
            if (x >= 0 && x <= 1) T_SL[i] = x;
            else return (false);
            
            x = StrToInteger(p[1]);
            T_SL_BUY[i] = x;
            

            x = StrToInteger(p[2]);
            T_SL_SELL[i] = x;
         }
         else {
            Print("T_INFO: Wrong number of arguments for SL");
            return (false);
         }
         //--- TP
         if (SplitString(s[1],";",p,2)) {
            x = StrToInteger(p[0]);
            if (x >= 0 && x <= 1) T_TP[i] = x;
            else return (false);
            
            x = StrToInteger(p[1]);
            T_TP_VAL[i] = x;
         }
         else {
            Print("T_INFO: Wrong number of arguments for TP");
            return (false);
         }
         //--- BE
         if (SplitString(s[2],";",p,3)) {
            x = StrToInteger(p[0]);
            if (x >= 0 && x <= 1) T_BE[i] = x;
            else return (false);
            
            x = StrToInteger(p[1]);
            T_BE_TRIG[i] = x;
            
            x = StrToInteger(p[2]);
            T_BE_DEV[i] = x;
         }
         else {
            Print("T_INFO: Wrong number of arguments for BE");
            return (false);
         }
         //--- TS
         if (SplitString(s[3],";",p,3)) {
            x = StrToInteger(p[0]);
            if (x >= 0 && x <= 1) T_TS[i] = x;
            else return (false);
            
            x = StrToInteger(p[1]);
            T_TS_TRIG[i] = x;
            
            x = StrToInteger(p[2]);
            T_TS_STEP[i] = x;
            
            T_TS_ARMED_B[i] = false;
            T_TS_ARMED_S[i] = false;
         }
         else {
            Print("T_INFO: Wrong number of arguments for TS");
            return (false);
         }
         //--- MM
         if (SplitString(s[4],";",p,2)) {
            x = StrToInteger(p[0]);
            if (x >= 0 && x <= 2) T_MM[i] = x;
            else return (false);
            
            y = StrToDouble(p[1]);
            if (y < MarketInfo(Symbol(),MODE_MINLOT)) y = MarketInfo(Symbol(),MODE_MINLOT);
            if (y > MarketInfo(Symbol(),MODE_MAXLOT)) y = MarketInfo(Symbol(),MODE_MAXLOT);
            T_MM_VAL[i] = y;
         }
         else {
            Print("T_INFO: Wrong number of arguments for MM");
            return (false);
         }
         //--- RE
         T_RE_B[i] = 0;
         T_RE_S[i] = 0;
      }
      else {
         return (false);
      }
   }
   return (true);
}
//+------------------------------------------------------------------+
//| Automatic GMT calculation functions                              |
//+------------------------------------------------------------------+
int GetShiftGMT() {
   int TimeArray[4];
   int TZInfoArray[43];
   double GMT_Offset;
   
   int GMT_Shift=0;
   int dst=GetTimeZoneInformation(TZInfoArray);
   if(dst!=0) GMT_Shift=TZInfoArray[0];
   if(dst==2) GMT_Shift+=TZInfoArray[42];

   datetime GMT = TimeLocal() + GMT_Shift * 60;
   datetime ClockDifference = TimeCurrent() - GMT - ((TimeHour(TimeCurrent())-TimeHour(GMT))*3600);
   int GMTOffset = TimeHour(TimeCurrent()-ClockDifference)-TimeHour(GMT);
   
   return (GMTOffset);
}
//+------------------------------------------------------------------+
//| comment the printArr on chart                                    |
//+------------------------------------------------------------------+
void CPA() {
   string printString = "";
   for (int i=0;i<=9;i++) {
      printString = printString + pA[i] + "\n";
   }
   Comment(printString);
}
//+------------------------------------------------------------------+
//| Split string function                                            |
//+------------------------------------------------------------------+
bool SplitString(string stringValue, string separatorSymbol, string& results[], int expectedResultCount = 0) {
   if (StringFind(stringValue, separatorSymbol) < 0) {
      ArrayResize(results, 1);
      results[0] = stringValue;
   }
   else {
      int separatorPos = 0;
      int newSeparatorPos = 0;
      int size = 0;

      while(newSeparatorPos > -1) {
         size = size + 1;
         newSeparatorPos = StringFind(stringValue, separatorSymbol, separatorPos);
         
         ArrayResize(results, size);
         if (newSeparatorPos > -1) {
            if (newSeparatorPos - separatorPos > 0) {
               results[size-1] = StringSubstr(stringValue, separatorPos, newSeparatorPos - separatorPos);
            }
         }
         else {
            results[size-1] = StringSubstr(stringValue, separatorPos, 0);
         }

         separatorPos = newSeparatorPos + 1;
      }
   }   
   
   if (expectedResultCount == 0 || expectedResultCount == ArraySize(results)) {
      return (true);
   }
   else {
      return (false);
   }
}
//+------------------------------------------------------------------+
//| Percentage MM function                                           |
//| Calculates the lot size based on percentage                      |
//+------------------------------------------------------------------+
double CalculateLotByRisk(double StopLoss,double RiskPercentage) {
   if (StopLoss < 0) StopLoss = StopLoss*(-1);
   if (Point == 0.00001) StopLoss = StopLoss/10;
   AccountValue = AccountEquity();
   double AtRisk = AccountValue * RiskPercentage / 100;
   double RiskPerPip = AtRisk / StopLoss;
   double Multiply = 0.1;
   if (QuoteCurr == "JPY") Multiply = 0.001;
   if (QuoteCurr != AccCurr) {
      //Try to convert the value
      string ConvSymbol = ReproduceSymbol(AccCurr + QuoteCurr,a,b,c);
      double ConvValue = MarketInfo(ConvSymbol,MODE_BID);
      if (ConvValue > 0) {
         RiskPerPip = RiskPerPip * ConvValue;
      }
      else {
         ConvSymbol = ReproduceSymbol(QuoteCurr + AccCurr,a,b,c);
         ConvValue = MarketInfo(ConvSymbol,MODE_BID);
         if (ConvValue > 0) RiskPerPip = RiskPerPip / ConvValue;
         else RiskPerPip = 0;
      }
   }
   
   return (NormalizeDouble(RiskPerPip * Multiply,2));  
}
//+------------------------------------------------------------------+
//| Normalize symbol function                                        |
//| Breaks the symbol down to CURCUR                                 |
//+------------------------------------------------------------------+
string NormalizeSymbol(string Sym,string a,string b,string c) {
   Sym = StringUpperCase(Sym);
   return (StringSubstr(Sym,StringLen(a),3)+StringSubstr(Sym,StringLen(a)+StringLen(b)+3,3));
}
//+------------------------------------------------------------------+
//| Reproduce symbol function                                        |
//| Reproduces the normalized symbol to the broker specific format   |
//+------------------------------------------------------------------+
string ReproduceSymbol(string Sym,string a,string b,string c) {
   Sym = StringUpperCase(Sym);
   return (a+StringSubstr(Sym,0,3)+b+StringSubstr(Sym,3,3)+c);
}
//+------------------------------------------------------------------+
//| Detect predimsuf function                                        |
//| Detects and returns the specific symbol attributes               |
//+------------------------------------------------------------------+
string DetectPredimsuf(string Sym) {
   Sym = StringUpperCase(Sym);
   int i,pos1=-1,pos2=-1,index;
   string sym1,sym2,temp,x="",y="",z="";
   for (i=0;i<=17;i++) {
      index = StringFind(Sym,Currencies[i]);
      if (index > -1) {
         if (pos1 == -1) {
            pos1 = index;
            sym1 = Currencies[i];
         }
         else {
            pos2 = index;
            sym2 = Currencies[i];
         }
      }
   }
   if (pos2 < pos1) {
      index = pos2;
      temp = sym2;
      pos2 = pos1;
      sym2 = sym1;
      pos1 = index;
      sym1 = temp;
   }
   
   if (pos1 > 0) x = StringSubstr(Sym,0,pos1);
   if (pos2 > pos1+3) y = StringSubstr(Sym,pos1+3,pos2-(pos1+3));
   if (StringLen(Sym) > pos2+3) z = StringSubstr(Sym,pos2+3);
   return (x+sym1+y+sym2+z+";"+x+";"+y+";"+z);
}
//+------------------------------------------------------------------+
//| String to upper case function                                    |
//+------------------------------------------------------------------+
string StringUpperCase(string str) {
   string s = str;
   int length = StringLen(str) - 1, symbol;
   while(length >= 0) {
      symbol = StringGetChar(s, length);
      if((symbol > 96 && symbol < 123) || (symbol > 223 && symbol < 256))
      s = StringSetChar(s, length, symbol - 32);
      else 
      if(symbol > -33 && symbol < 0)
      s = StringSetChar(s, length, symbol + 224);
      length--;
   }
   return(s);
}
//+------------------------------------------------------------------+